<template>
  <dx-popup
    :drag-enabled="false"
    :visible.sync="isOpen"
    :show-title="false"
    class="admin-member-type"
    @hiding="closePopup"
  >
    <div class="popup-upper">
      <div
        v-show="modalPhase === $options.modalPhases[0]"
      >
        <h3 class="popup-header">
          Роль пользователя
        </h3>
        <select-box-group
          :edit-function="selectedFunction"
          @change="change"
        />
        <functional-grid-panel
          :columns="$options.roleColumns"
          :header-class="'popup-edit-table'"
          :add-tab-enable="true"
          :add-tab-click="changePhase"
          :add-tab-active="true"
        />
      </div>
      <div
        v-show="modalPhase === $options.modalPhases[1]"
      >
        <h3
          class="popup-header"
        >
          <img
            :src="require('/src/static/icons/arrow-blue-left.svg')"
            @click="changePhase"
          >
          Список функцийW
        </h3>
        <functional-grid-panel
          :columns="$options.functionColumns"
          :header-class="'popup-edit-table'"
          :add-tab-enable="true"
        />
      </div>
    </div>
    <div class="popup-body">
      <div
        v-show="modalPhase === $options.modalPhases[0]"
        class="table-container"
      >
        <data-grid
          ref="selectedFunc"
          :columns="$options.roleColumns"
          data-grid-ref-name="selectedFunc"
          :pagination-enabled="false"
          :min-cell-width="undefined"
          :table-class="'popup-member-grid-table'"
          :source="functions.excludedFunctions"
          :footer-class="'popup-table-footer'"
          :show-edit-img="true"
          :load-func="onLoad"
          :remove-func="onRemove"
        />
      </div>
      <div
        v-show="modalPhase === $options.modalPhases[1]"
        class="table-container"
      >
        <data-grid
          ref="addGrid"
          data-grid-ref-name="addGrid"
          :columns="$options.functionColumns"
          :pagination-enabled="false"
          :min-cell-width="undefined"
          :table-class="'popup-functions-grid-table with-radios'"
          :source="functions.excludedFunctions"
          :footer-class="'popup-table-footer'"
          :edit="false"
          :multi-select-enabled="true"
          :load-func="onAddLoad"
          @onSelect="updateSelectedFunctions"
        />
      </div>
    </div>
    <div class="popup-controls">
      <dx-button
        class="cancel-btn"
        :active-state-enabled="false"
        styling-mode="text"
        text="Отмена"
        @click="closePopup"
      />
      <dx-button
        class="save-btn"
        type="default"
        styling-mode="contained"
        :text="modalPhase === $options.modalPhases[0]? 'Сохранить' : 'Добавить'"
        @click="save"
      />
    </div>
  </dx-popup>
</template>
<script>
import DxPopup from 'devextreme-vue/popup'
import SelectBoxGroup from '../components/SelectBoxGroup.vue'
import FunctionalGridPanel from '../components/FunctionalGridPanel.vue'
import DataGrid from 'common-components/src/obComponents/obDataGrid'
import { DxButton } from 'devextreme-vue'

const typeColumns = [
  {
    title: 'C',
    field: 'create',
    width: '52px',
    template: 'radioBtn',
    className: 'radio-cell'

  },
  {
    title: 'R',
    field: 'read',
    width: '52px',
    template: 'radioBtn',
    className: 'radio-cell'

  },
  {
    title: 'U',
    field: 'update',
    width: '52px',
    template: 'radioBtn',
    className: 'radio-cell'

  },
  {
    title: 'D',
    field: 'delete',
    width: '52px',
    template: 'radioBtn',
    className: 'radio-cell'

  },
  {
    title: 'E',
    field: 'edit',
    width: '52px',
    template: 'radioBtn',
    className: 'radio-cell cell-shadow'
  }
]

export default {
  modalPhases: ['modal', 'editFunctions'],
  roleColumns: [
    {
      title: 'Функция',
      field: 'title',
      className: 'function-cell'
    },
    {
      title: 'Тип',
      field: 'type',
      width: '85px',
      className: 'type-cell'
    },
    ...typeColumns
  ],
  functionColumns: [
    {
      title: 'Функция',
      field: 'title',
      className: 'function-cell'
    },
    {
      title: 'Тип',
      field: 'type',
      width: '85px',
      className: 'type-cell'
    },
    ...typeColumns
  ],
  name: 'EditWorkerRole',
  components: {
    SelectBoxGroup,
    FunctionalGridPanel,
    DataGrid,
    DxPopup,
    DxButton

  },
  props: {
    isOpen: {
      type: Boolean,
      required: true
    },
    selectedFunction: {
      type: Object,
      required: true
    }
  },
	data: function () {
		return {
			modalName: 'AdminMemberType',
			modalPhase: this.$options.modalPhases[0],
			onlyFunctions: false,
			dataToEdit: {},
			functions: {
        addedFunctions: [],
        excludedFunctions: [],
        filter: [],
        functions: [],
        visibility: [],
			}
		}
	},
  methods: {
    refresh () {
      this.$refs.addGrid.refresh()
      this.$refs.selectedFunc.refresh()
      const linkedUuids = this.functions.excludedFunctions
        .filter(el => el.isLinked)
        .map(el => el.uuid)
      this.$refs.addGrid.selectRows(
        this.functions.functions.filter(el => linkedUuids.includes(el.uuid))
      )
    },
    changePhase () {
      this.modalPhase = this.modalPhase === this.$options.modalPhases[0]
        ? this.$options.modalPhases[1]
        : this.$options.modalPhases[0]
    },
    updateSelectedFunctions (event) {
      if (event.currentDeselectedRowKeys.length > 0) {
        this.$nextTick(() => {
          this.setExcludedFunctionLink({
            funcUuids: event.currentDeselectedRowKeys.map(el => el.uuid),
            isLinked: false
          })
        })
      }
      if (event.currentSelectedRowKeys.length > 0) {
        this.$nextTick(() => {
          this.setExcludedFunctionLink({
            funcUuids: event.currentSelectedRowKeys.map(el => el.uuid),
            isLinked: true
          })
        })
      }

      this.$refs.selectedFunc.refresh()
    },
    closePopup () {
      this.$emit('close')
      this.modalPhase = this.$options.modalPhases[0]
      this.clearExcludedFunctions()
      this.$refs.addGrid.refresh()
      this.$refs.selectedFunc.refresh()
    },
    save () {
      if (this.modalPhase !== this.$options.modalPhases[0]) {
        this.changePhase()
      } else {
        const linkUuids = this.functions.excludedFunctions
          .filter(el => el.isLinked)
          .map(el => el.uuid)
        this.clearExcludedFunctions()
        this.$refs.addGrid.refresh()
        this.$refs.selectedFunc.refresh()
        this.$emit('save', {
          title: this.dataToEdit.title,
          status: this.dataToEdit.status,
          links: linkUuids
        })
      }
    },
    ...mapActions([
      'getFunctions',
      'getUserRoleFunctions',
      'getExcludedFunctions',
      'clearExcludedFunctions',
      'deleteExcludedFunction',
      'setExcludedFunctionLink',
      'removeLink'
    ]),
    onLoad (loadOptions) {
      console.log(loadOptions)
      return this.getExcludedFunctions({
        skip: loadOptions.skip,
        take: loadOptions.take,
        isLinkedOnly: true
      })
        .catch(() => { throw Error('Data Loading Error') })
    },
    onRemove (key) {
      this.functions.excludedFunctions.find(el => el.uuid === key.uuid).isLinked = false
      this.$refs.addGrid.deselectRows(
        [this.functions.functions.find(el => el.uuid === key.uuid)]
      )
    },
    onAddLoad (loadOptions) {
      return this.getFunctions({
        skip: loadOptions.skip,
        take: loadOptions.take
      })
        .catch(() => { throw Error('Data Loading Error') })
    },
    change (event) {
      this.dataToEdit = event
    }
  }
}
</script>
<style lang="scss" scoped>

</style>
